﻿namespace MeinStapel
{
    public class SimpleStack<T>
    {
        // **************************************
        // Eine Klasse, die nur innerhalb von
        // SimpleStack verwendet wird
        // Ein Stack-Element
        public class SimpleStackNode<X>
        {
            public T Data { get; set; }
            public SimpleStackNode<X> Next { get; set; }

            public SimpleStackNode()
            {
                Data = default(T);
                Next = null;
            }
            public SimpleStackNode(T data)
            {
                Data = data;
                Next = null;
            }
        }
        // Ende der Klassendefinition
        // **************************************

        // Attribute von SimpleStack
        public int Count;
        private SimpleStackNode<T> head { get; set; }

        // Konstruktor für SimpleStack
        public SimpleStack()
        {
            Count = 0;
            head = new SimpleStackNode<T>();
        }

        public void Push(T data)
        {
            // Neues Stack-Element erzeugen
            SimpleStackNode<T> tmp = new SimpleStackNode<T>(data);

            // Zwei Fälle:
            // 1. Stack ist leer
            // 2. Stack ist nicht leer

            if (Count == 0)
                head.Next = tmp;
            else
            {
                tmp.Next = head.Next;
                head.Next = tmp;
            }

            Count++;
        }

        public T Pop()
        {
            SimpleStackNode<T> rc = new SimpleStackNode<T>();

            // Zwei Fälle:
            // 1. Queue ist leer
            // 2. Queue ist nicht leer

            if (Count > 0)
            {
                rc = head.Next;
                head.Next = head.Next.Next;
                Count--;
            }

            return rc.Data;
        }

        public T Peek()
        {
            SimpleStackNode<T> rc = new SimpleStackNode<T>();

            // Zwei Fälle:
            // 1. Queue ist leer
            // 2. Queue ist nicht leer

            if (Count > 0)
                rc = head.Next;

            return rc.Data;
        }

        public void ClearStack()
        {
            while (Count > 0)
                Pop();
        }

    }
}
