﻿namespace MeineListe
{
    public class SimpleList<T>
    {
        private SimpleListNode<T> head { get; set; }
        private SimpleListNode<T> tail { get; set; }

        public int Count { get; set; }

        public SimpleList()
        {
            head = new SimpleListNode<T>();
            tail = new SimpleListNode<T>();
        }

        public T getElementAt(int idx)
        {
            // Zwei Fälle:
            // 1. Liste ist noch leer --> Rückgabe default(T)
            // 2. Liste hat Elemente --> Rückgabe der Daten(i)

            SimpleListNode<T> rc = null;

            // Der Wert von idx muss kleiner Count sein!
            // Daher wird der Standardwert vom Datentyp T zurück geliefert
            if (idx >= Count)
                return default(T);

            if (Count > 0)
            {
                rc = head.Next;

                for (int i = 0; i < idx; i++)
                {
                    rc = rc.Next;
                }
            }

            return rc.Data;
        }
        public void Add(T data)
        {
            // Es wird am Ende der Liste angefügt
            // Zwei Fälle:
            // 1. Liste ist noch leer --> head und tail
            // zeigen auf den neuen Listnode
            // 2. List war nicht leer
            // Bisher letzter Listnode muss auf neuen
            // Listnode zeigen und tail zeigt auf
            // neuen Listnode

            SimpleListNode<T> ln = new SimpleListNode<T>(data);

            if ((head.Next == null) && (tail.Next == null))
            {
                head.Next = ln;
                tail.Next = ln;
            }
            else
            {
                tail.Next.Next = ln;
                tail.Next = ln;
                ln.Next = null;
            }

            Count++;
        }

        public T removeElementAt(int idx)
        {
            // Zwei Fälle:
            // 1. Liste ist noch leer --> Rückgabe default(T)
            // 2. Liste hat Elemente --> Entfernen und Rückgabe des Element(i)

            SimpleListNode<T> rc = null;

            // Der Wert von idx muss kleiner Count sein!
            // Daher wird der Standardwert vom Datentyp T zurück geliefert
            if (idx >= Count)
                return default(T);

            if (Count > 0)
            {
                rc = head;

                for (int i = 0; i < idx; i++)
                {
                    rc = rc.Next;
                }

                // Nach Durchlaufen der Schleife ist
                // rc das Listenelement vor dem zu
                // entfernenden Listenelement.
                // Nun müssen die Verweise angepasst werden

                // Zuerst den Verweis auf das zu entfernende
                // Listenelement speichern für die Rückgabe
                SimpleListNode<T> tmp = rc.Next;

                // Nun das Listenelement vor dem zu entfernenden
                // auf den Nachfolger des zu entfernenden zeigen lassen
                rc.Next = tmp.Next;

                // Falls das entfernte Listenelement das letzte
                // Element in der Liste war, muss noch tail
                // angepasst werden

                if (idx == Count - 1)
                    tail = rc;

                rc = tmp;

                Count--;
            }

            return rc.Data;
        }
    }
}
