﻿namespace MeineSchlange
{
    public class SimpleQueue<T>
    {
        // **************************************
        // Eine Klasse, die nur innerhalb von
        // SimpleQueue verwendet wird
        // Ein Queue-Element
        public class SimpleQueueNode<X>
        {
            public T Data { get; set; }
            public SimpleQueueNode<X> Next { get; set; }

            public SimpleQueueNode()
            {
                Data = default(T);
                Next = null;
            }
            public SimpleQueueNode(T data)
            {
                Data = data;
                Next = null;
            }
        }
        // Ende der Klassendefinition
        // **************************************

        // Attribute von SimpleQueue
        public int Count;
        private SimpleQueueNode<T> head { get; set; }
        private SimpleQueueNode<T> tail { get; set; }

        // Konstruktor für SimpleQueue
        public SimpleQueue()
        {
            Count = 0;
            head = new SimpleQueueNode<T>();
            tail = new SimpleQueueNode<T>();
        }

        public void Enqueue(T data)
        {
            // Neues Queue-Element erzeugen
            SimpleQueueNode<T> tmp = new SimpleQueueNode<T>(data);

            // Zwei Fälle:
            // 1. Queue ist leer
            // 2. Queue ist nicht leer

            if (Count == 0)
                head.Next = tail.Next = tmp;
            else
            {
                tail.Next.Next = tmp;
                tail.Next = tmp;
            }

            Count++;
        }

        public T Dequeue()
        {
            SimpleQueueNode<T> rc = new SimpleQueueNode<T>();

            // Zwei Fälle:
            // 1. Queue ist leer
            // 2. Queue ist nicht leer

            if (Count > 0)
            {
                rc = head.Next;
                head.Next = head.Next.Next;
                // Wenn das letzte Element entfernt wird
                // muss tail.Next auf null stehen
                if (head.Next == null)
                    tail.Next = null;
                Count--;
            }

            return rc.Data;
        }

        public T Peek()
        {
            SimpleQueueNode<T> rc = new SimpleQueueNode<T>();

            // Zwei Fälle:
            // 1. Queue ist leer
            // 2. Queue ist nicht leer

            if (Count > 0)
                rc = head.Next;

            return rc.Data;
        }

        public void ClearQueue()
        {
            while (Count > 0)
                Dequeue();
        }

    }
}
